package com.nisum.ascend.inventory.dto;

import lombok.AllArgsConstructor;
import lombok.Getter;
import com.nisum.ascend.inventory.model.Product;

@Getter
@AllArgsConstructor
public class ProductDto {
    private String sku;
    private String upc;
    private String productName;
    private String productDescription;
    private float price;
    private String productImageUrl;
    private String brand;
    private String category;
    private int stock;
    private PromotionDto promotion;


    public static ProductDto generateDtoFromProduct(Product product) {
        // TODO: Fetch the product's promotion from the Promotions com.nisum.ascend.inventory.service
        PromotionDto promotion = new PromotionDto();

        return new ProductDto(product.getSku(), product.getUpc(), product.getProductName(), product.getProductDescription(), product.getPrice(), product.getProductImageUrl(), product.getBrand(), product.getCategory(), product.getAvailableStock(), promotion);

    }
}
